Subject: Re: [PATCH iproute2-next v11] Add support for CAKE qdisc

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Thu, 19 Jul 2018 18:47:16 +0200

David Ahern <[email-masked]> writes:

> On 7/19/18 7:56 AM, Toke Høiland-Jørgensen wrote:
>> sch_cake is intended to squeeze the most bandwidth and latency out of even
>> the slowest ISP links and routers, while presenting an API simple enough
>> that even an ISP can configure it.
>> 
>> Example of use on a cable ISP uplink:
>> 
>> tc qdisc add dev eth0 cake bandwidth 20Mbit nat docsis ack-filter
>> 
>> To shape a cable download link (ifb and tc-mirred setup elided)
>> 
>> tc qdisc add dev ifb0 cake bandwidth 200mbit nat docsis ingress wash besteffort
>> 
>> Cake is filled with:
>> 
>> * A hybrid Codel/Blue AQM algorithm, "Cobalt", tied to an FQ_Codel
>>   derived Flow Queuing system, which autoconfigures based on the bandwidth.
>> * A novel "triple-isolate" mode (the default) which balances per-host
>>   and per-flow FQ even through NAT.
>> * An deficit based shaper, that can also be used in an unlimited mode.
>> * 8 way set associative hashing to reduce flow collisions to a minimum.
>> * A reasonable interpretation of various diffserv latency/loss tradeoffs.
>> * Support for zeroing diffserv markings for entering and exiting traffic.
>> * Support for interacting well with Docsis 3.0 shaper framing.
>> * Support for DSL framing types and shapers.
>> * Support for ack filtering.
>> * Extensive statistics for measuring, loss, ecn markings, latency variation.
>> 
>> Various versions baking have been available as an out of tree build for
>> kernel versions going back to 3.10, as the embedded router world has been
>> running a few years behind mainline Linux. A stable version has been
>> generally available on lede-17.01 and later.
>> 
>> sch_cake replaces a combination of iptables, tc filter, htb and fq_codel
>> in the sqm-scripts, with sane defaults and vastly simpler configuration.
>> 
>> Cake's principal author is Jonathan Morton, with contributions from
>> Kevin Darbyshire-Bryant, Toke Høiland-Jørgensen, Sebastian Moeller,
>> Ryan Mounce, Tony Ambardar, Dean Scarff, Nils Andreas Svee, Dave Täht,
>> and Loganaden Velvindron.
>> 
>> Testing from Pete Heist, Georgios Amanakis, and the many other members of
>> the [email-masked] mailing list.
>> 
>> Signed-off-by: Dave Taht <[email-masked]>
>> Signed-off-by: Toke Høiland-Jørgensen <[email-masked]>
>> ---
>
> applied to iproute2-next. Thanks

Great, thanks!

> About the autorate, I think you should consider consistency in output.

Yeah, I'd tend to agree. Did actually send an updated patch, but guess
the streams crossed. Can send a separate patch with the rename; I see I
forgot to update the man page anyway...

-Toke